## clpeak 1.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(clpeak)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/common.cmake)

if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()

find_package(OpenCL)
if(NOT OpenCL_FOUND)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
  include(BuildIcd)
  find_package(OpenCL REQUIRED)
endif()

# extra libs for static library
if(UNIX AND ${OpenCL_LIBRARIES} MATCHES "libOpenCL.a")
  set(OpenCL_LIBRARIES ${OpenCL_LIBRARIES} pthread dl)
elseif(WIN32 AND ${OpenCL_LIBRARIES} MATCHES "OpenCL.lib")
  set(OpenCL_LIBRARIES ${OpenCL_LIBRARIES} cfgmgr32.lib)
endif()

FIND_PATH(HPP_FOUND CL/cl.hpp PATHS ${OpenCL_INCLUDE_DIRS})
if(NOT HPP_FOUND)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
  include(BuildCLHpp)
  set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIRS} "${CLHPP_ROOT}/include")
endif()

if(NOT OpenCL_FOUND)
  message(FATAL_ERROR "Could not find OpenCL include/libs. Set OCL_ROOT to your OpenCL SDK")
else()
  message(STATUS "Selected OpenCL includes from ${OpenCL_INCLUDE_DIRS}")
  message(STATUS "Selected OpenCL lib ${OpenCL_LIBRARIES}")
endif()

set(CMAKE_CXX_STANDARD "11")
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CLPEAK_SOURCE_FILES
    src/common.cpp
    src/clpeak.cpp
    src/options.cpp
    src/logger.cpp
    src/global_bandwidth.cpp
    src/compute_sp.cpp
    src/compute_hp.cpp
    src/compute_dp.cpp
    src/compute_integer.cpp
    src/transfer_bandwidth.cpp
    src/kernel_latency.cpp
    src/entry.cpp
)

add_executable(clpeak ${CLPEAK_SOURCE_FILES})
target_link_libraries(clpeak ${OpenCL_LIBRARIES})
target_include_directories(clpeak PRIVATE ${OpenCL_INCLUDE_DIRS} "include" "src/kernels")
target_compile_definitions(clpeak PRIVATE CL_TARGET_OPENCL_VERSION=120)

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR
   CMAKE_CXX_COMPILER_ID STREQUAL "GNU"   OR
   CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  target_compile_options(clpeak PRIVATE -fPIC -Wall -Wextra -Wconversion -Wno-deprecated-declarations -Wno-unused-parameter -Wno-ignored-attributes)
elseif(MSVC)
  target_compile_options(clpeak PRIVATE /wd4996)
endif()

install(TARGETS clpeak RUNTIME DESTINATION bin)
install(FILES LICENSE DESTINATION share/clpeak)

enable_testing()
add_test(clpeak_test_run clpeak)

set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${VERSION_STR}")
set(CPACK_GENERATOR "ZIP")
include (CPack)

=== android/app/src/main/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)

# Build stub
add_subdirectory(libopencl-stub)

set(ROOT_FOLDER "../../../../..")
include(${ROOT_FOLDER}/cmake/common.cmake)

set(SRC_FOLDER "${ROOT_FOLDER}/src")
add_library(clpeak SHARED
        ${SRC_FOLDER}/common.cpp
        ${SRC_FOLDER}/clpeak.cpp
        ${SRC_FOLDER}/global_bandwidth.cpp
        ${SRC_FOLDER}/compute_sp.cpp
        ${SRC_FOLDER}/compute_hp.cpp
        ${SRC_FOLDER}/compute_dp.cpp
        ${SRC_FOLDER}/compute_integer.cpp
        ${SRC_FOLDER}/transfer_bandwidth.cpp
        ${SRC_FOLDER}/kernel_latency.cpp
        ${SRC_FOLDER}/entry_android.cpp
        ${SRC_FOLDER}/options.cpp
        ${SRC_FOLDER}/logger_android.cpp
)

target_include_directories(clpeak PRIVATE
        libopencl-stub/include/
        ${ROOT_FOLDER}/include/
        ${SRC_FOLDER}/kernels/
)

target_compile_definitions(clpeak PRIVATE ANDROID_LOGGER USE_STUB_OPENCL)
target_compile_options(clpeak PRIVATE -fPIC -O2 -fexceptions)
target_link_libraries(clpeak log atomic dl OpenCL)

=== debian/changelog ===
clpeak (1.1.0-2) unstable; urgency=medium

  * Source-only upload to migrate into testing 

 -- Neil Williams <codehelp@debian.org>  Fri, 12 Nov 2021 12:08:46 +0000

clpeak (1.1.0-1) unstable; urgency=medium

  * Initial release (Closes: #994549)
  * Include patch from upstream to use opencl.hpp
  * Add OpenCL team as Maintainer

 -- Neil Williams <codehelp@debian.org>  Fri, 17 Sep 2021 16:12:45 +0100

=== debian/control ===
Source: clpeak
Section: devel
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Neil Williams <codehelp@debian.org>,
Build-Depends:
	debhelper-compat (= 13),
	cmake,
	ocl-icd-opencl-dev,
Standards-Version: 4.6.0
Homepage: https://github.com/krrishnarraj/clpeak
Vcs-Browser: https://salsa.debian.org/opencl-team/clpeak
Vcs-Git: https://salsa.debian.org/opencl-team/clpeak.git
Rules-Requires-Root: no

Package: clpeak
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Profile OpenCL devices to find peak capacities
 Clpeak is a synthetic benchmarking tool to measure peak capabilities
 of opencl devices. It only measures the peak metrics that can be
 achieved using vector operations and does not represent a real-world
 use case

## clpeak 1.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(clpeak)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/common.cmake)

if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()

find_package(OpenCL)
FIND_PATH(HPP_FOUND CL/opencl.hpp PATHS ${OpenCL_INCLUDE_DIRS})
if(NOT OpenCL_FOUND OR NOT HPP_FOUND)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
  include(BuildSdk)

  find_package(OpenCL REQUIRED)

  set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIRS} "${SDK_ROOT}/include")
  FIND_PATH(HPP_FOUND CL/opencl.hpp PATHS ${OpenCL_INCLUDE_DIRS} REQUIRED)
endif()

if(NOT OpenCL_FOUND)
  message(FATAL_ERROR "Could not find OpenCL include/libs. Set OCL_ROOT to your OpenCL SDK")
else()
  message(STATUS "Selected OpenCL includes from ${OpenCL_INCLUDE_DIRS}")
  message(STATUS "Selected OpenCL lib ${OpenCL_LIBRARIES}")
endif()

# extra libs for static library
if(UNIX AND ${OpenCL_LIBRARIES} MATCHES "libOpenCL.a")
  set(OpenCL_LIBRARIES ${OpenCL_LIBRARIES} pthread dl)
elseif(WIN32 AND ${OpenCL_LIBRARIES} MATCHES "OpenCL.lib")
  set(OpenCL_LIBRARIES ${OpenCL_LIBRARIES} cfgmgr32.lib runtimeobject.lib)
endif()

set(CMAKE_CXX_STANDARD "11")
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CLPEAK_SOURCE_FILES
    src/common.cpp
    src/clpeak.cpp
    src/options.cpp
    src/logger.cpp
    src/global_bandwidth.cpp
    src/compute_sp.cpp
    src/compute_hp.cpp
    src/compute_dp.cpp
    src/compute_integer.cpp
    src/compute_integer_fast.cpp
    src/transfer_bandwidth.cpp
    src/kernel_latency.cpp
    src/entry.cpp
)

add_executable(clpeak ${CLPEAK_SOURCE_FILES})
target_link_libraries(clpeak ${OpenCL_LIBRARIES})
target_include_directories(clpeak PRIVATE ${OpenCL_INCLUDE_DIRS} "include" "src/kernels")
target_compile_definitions(clpeak PRIVATE CL_TARGET_OPENCL_VERSION=120)

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR
   CMAKE_CXX_COMPILER_ID STREQUAL "GNU"   OR
   CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  target_compile_options(clpeak PRIVATE -fPIC -Wall -Wextra -Wno-unused-parameter)
endif()

install(TARGETS clpeak RUNTIME DESTINATION bin)
install(FILES LICENSE DESTINATION share/clpeak)

enable_testing()
add_test(clpeak_test_run clpeak)

set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${VERSION_STR}")
set(CPACK_GENERATOR "ZIP")
include (CPack)

=== android/app/src/main/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
         ${SRC_FOLDER}/compute_hp.cpp
         ${SRC_FOLDER}/compute_dp.cpp
         ${SRC_FOLDER}/compute_integer.cpp
+        ${SRC_FOLDER}/compute_integer_fast.cpp
         ${SRC_FOLDER}/transfer_bandwidth.cpp
         ${SRC_FOLDER}/kernel_latency.cpp
         ${SRC_FOLDER}/entry_android.cpp

=== debian/changelog ===
clpeak (1.1.2-4) unstable; urgency=medium

  * d/t/control: Restrict architecture for the pocl test.
  * d/t/upstream-binaries: Fixed once again

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 13 Oct 2024 06:30:02 +0200

clpeak (1.1.2-3) unstable; urgency=medium

  * d/t/control: Added test with pocl and fix the rocm test

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 12 Oct 2024 10:30:40 +0200

clpeak (1.1.2-2) unstable; urgency=medium

  * Team upload
  * d/t/*: first attempt to add amd-ci tests

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 09 Oct 2024 17:43:59 +0200

clpeak (1.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch now applied upstream
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Neil Williams <codehelp@debian.org>  Fri, 22 Apr 2022 14:22:05 +0100

## clpeak 1.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 project(clpeak)
 
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/common.cmake)
+include(GNUInstallDirs)
 
 if (NOT CMAKE_BUILD_TYPE)
   message(STATUS "Setting build type to Release")
@@ -48,6 +49,8 @@
     src/compute_dp.cpp
     src/compute_integer.cpp
     src/compute_integer_fast.cpp
+    src/compute_char.cpp
+    src/compute_short.cpp
     src/transfer_bandwidth.cpp
     src/kernel_latency.cpp
     src/entry.cpp
@@ -65,7 +68,7 @@
 endif()
 
 install(TARGETS clpeak RUNTIME DESTINATION bin)
-install(FILES LICENSE DESTINATION share/clpeak)
+install(FILES LICENSE DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/clpeak")
 
 enable_testing()
 add_test(clpeak_test_run clpeak)

=== debian/changelog ===
clpeak (1.1.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 20 Dec 2024 11:54:33 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	debhelper-compat (= 13),
 	cmake,
 	ocl-icd-opencl-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Homepage: https://github.com/krrishnarraj/clpeak
 Vcs-Browser: https://salsa.debian.org/opencl-team/clpeak
 Vcs-Git: https://salsa.debian.org/opencl-team/clpeak.git

## clpeak 1.1.5

=== debian/changelog ===
clpeak (1.1.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 14:39:33 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	debhelper-compat (= 13),
 	cmake,
 	ocl-icd-opencl-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/krrishnarraj/clpeak
 Vcs-Browser: https://salsa.debian.org/opencl-team/clpeak
 Vcs-Git: https://salsa.debian.org/opencl-team/clpeak.git

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DOpenCL_INCLUDE_DIRS=/usr/include/CL

override_dh_auto_install:
	dh_auto_install
	dh_installman debian/clpeak.1
	# drop copy of LICENSE file and empty dir.
	$(RM) -rf debian/clpeak/usr/share/clpeak/

=== debian/tests/control ===
Test-Command: clpeak
Depends: clpeak, pocl-opencl-icd
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 armel armhf i386

Test-Command: /bin/sh debian/tests/upstream-binaries clpeak
Depends: clpeak, rocminfo, rocm-opencl-icd
Restrictions: skippable, allow-stderr, needs-sudo
Architecture: amd64 arm64 ppc64el

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%clpeak-$1.tar.gz%" \
   https://github.com/krrishnarraj/clpeak/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
